module StarkitBanking
  module RBL
    module Payment
      class GetStatus
        include ApiClient

        private

        def service_name
          'STATUS ENQUIRY'
        end

        def invoke(env, req, callbacks)
          ApiBanking::GetPaymentStatus.get_status(env, req, callbacks)
        end

        def response(res)
          Transfer::Status.new(res.statusCode, res.bankReferenceNo, '')
        end

        def credentials(payment)
          payment.payment_account.credentials
        end

        def request(subscription, payment)
          
          header = ApiBanking::GetPaymentStatus::ReqHeader.new()
          reqBody = ApiBanking::GetPaymentStatus::ReqBody.new()
          request = ApiBanking::GetPaymentStatus::Request.new()

          header.corpID          = subscription.app_id
          header.approverID      = payment.created_by

          reqBody.referenceNo = payment.id.to_s

          request.header = header
          request.body = reqBody

          request
        end

        def subscription(payment)
          payment.payment_account.service_subscriptions.find_by(service_name: service_name)
        end

      end
    end
  end
end

