module StarkitBanking
  module Sync
    module Beneficiary
      
      class Job < ApplicationJob
        def perform(*args)
          Activity.exec(action, class_name, obj_id)
        end
      end
            
      class Activity
        
        def self.exec(action, class_name, id)          
          b = class_name.constantize.find(id)
                    
          # get the steps
          # call step-engine
          # update result in beneficiary
          
          b.synced_version = b.lock_version
          b.synced_at = Time.now
          b.save
        end
        
        private
        
        def self.steps(action, beneficiary)
          if payment.payment_account.bank_name == "YBL"
            subscription = payment.payment_account.service_subscriptions.find_by(service_name: Finance::ServiceSubscription::IMT_TRANSFER)
            if action == ADD
              [StarkitBanking::Sync::Beneficiary::ByIMT.new(action, subscription, credentials)]
            elsif action == MOD
              [StarkitBanking::Sync::Beneficiary::ByIMT.new(DEL, subscription, credentials),
              StarkitBanking::Sync::Beneficiary::ByIMT.new(ADD, subscription, credentials)]
            end
          end
        end
        
      end
    end
  end
end

# orchestratable gem (see the code for pre-requisites) : for pass-word availability & restart when api's are down
# unique_job support in active-job, perform_later should return a false

beneficiary
  after_save
     StarkitBanking::Sync::Beneficiary::Job.perform_later(:ADD, self.class_name, self.id)
     StarkitBanking::Sync::Beneficiary::Activity.exec(:ADD, self.class_name, self.id)