module StarkitBanking
  module YBL
    module Payment
      class GetStatus
        include ApiClient

        private

        def service_name
          'STATUS ENQUIRY'
        end

        def invoke(env, req, callbacks)
          ApiBanking::FundsTransferByCustomerService2.get_status(env, req, callbacks)
        end

        def response(res)
          Transfer::Status.new(res.transactionStatus.statusCode, res.transactionStatus.bankReferenceNo, res.transferType)
        end

        def credentials(payment)
          payment.payment_account.credentials
        end

        def request(subscription, payment)

          request = ApiBanking::FundsTransferByCustomerService2::GetStatus::Request.new()

          request.appID = subscription.app_id
          request.customerID = payment.payment_account.customer_id
          request.requestReferenceNo = payment.id

          request
        end

        def subscription(payment)
          payment.payment_account.service_subscriptions.find_by(service_name: service_name)
        end

      end
    end
  end
end

